//!	EOS_InterruptRising.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_InterruptRising_h_
#define _EOS_InterruptRising_h_


//--------------------------- include section -----------------------
#include "types.h"
#include "EOS_Interrupt.h"


//--------------------------- class definition ----------------------
//! this class represents an abstraction of an interrupt source, that
//! will be triggered on an raising edge
class CEOS_InterruptRising :
        virtual public CEOS_Interrupt
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_InterruptRising);


//--------------------------- public virtual access -----------------
public:
    // enableInterruptRising ----------------------------------------
    //! enables the raising edge interrupt
    virtual void enableInterruptRising(bool_t bEnabled) = 0;
};


#endif
