//!	EOS_Macros.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_Macros_h_
#define _EOS_Macros_h_


//--------------------------- public macros -------------------------
    // NO_COPY_AND_ASSIGNMENT ---------------------------------------
    #define NO_COPY_AND_ASSIGNMENT(C) \
        private: C(const C&); \
        private: void operator=(const C&)

    // CONSTRUCTOR_NO_COPY_AND_ASSIGNMENT ---------------------------
    #define CONSTRUCTOR_NO_COPY_AND_ASSIGNMENT(C) \
        public: C(); \
        NO_COPY_AND_ASSIGNMENT(C)

    // CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT ---------------------
    #define CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(C) \
        public: inline C() {} \
        NO_COPY_AND_ASSIGNMENT(C)

    // CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT --
    #define CONSTRUCTOR_EMPTY_VIRTUAL_DESTRUCTOR_NO_COPY_AND_ASSIGNMENT(C) \
        public: inline C() {} \
        public: inline virtual ~C() {} \
        NO_COPY_AND_ASSIGNMENT(C)


#endif
