//!	EOS_USART.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_USART_h_
#define _EOS_USART_h_


//--------------------------- include section -----------------------
#include "EOS_RxStream.h"
#include "EOS_TxStream.h"


//--------------------------- class definition ----------------------
//! CEOS_USART represents an USART of the MCU
//! \code
//! class CUSART0 :
//!     public CEOS_USART
//! \endcode
class CEOS_USART :
        public CEOS_RxStream,
        public CEOS_TxStream
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_USART);


//--------------------------- public virtual access -----------------
public:
    // setRate ------------------------------------------------------
    //! This is a pure virtual function.
    //! Set the baudrate of the USART
    //! \pParam nRate is the bit rate of the USART
    virtual void setRate(unsigned int nRate) = 0;

};


#endif
